/******************************************************************************/
/*                                  COB2SQL                                   */
/*             Copyright (C) 1998 PhysTech, Inc. All rights reserved          */
/*                   Author: Sergei Viznyuk <sv@phystech.com>                 */
/*             Permission granted to distribute and use this program          */
/*               at your own risk. No warranty, explicit or implied.          */
/******************************************************************************/
#define BUFFSIZE	256
#define MAXCOLUMNS	8
#define MAXCOLNAME	64

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
/******************************************************************************/
int main(argn,argc)
int argn;
char *argc[];
{
int m,d;
register char *s;
char buf[BUFFSIZE];
char colname[MAXCOLUMNS][MAXCOLNAME];
FILE *fin=stdin;
register int i=1;
register int j=1;
int k=0;
int f=0;
int n=1;
int l=1;

while ( argc[i] )
  if ( argc[i][0] == '-' )
pr: switch ( argc[i][l] )
      {
	case 0:
	  i++;
	  l=1;
	  break;
       	case 'l':
	  l++;
	  f=1;
	  goto pr;
	case 's':
	  l++;
	  f=0;
	  goto pr;
	default:
us:	  fprintf(stderr,"\
usage: cob2sql [-sl] [input_file]\n\
-s flag turns on Cobol to SQL CREATE TABLE mode (default)\n\
-l flag turns on Cobol to SQL*Loader control file mode\n");
          exit(1);
      }
  else
    argc[j++]=argc[i++];

if ( j > 2 )
  {
    fprintf(stderr,"cob2sql: too many arguments\n");
    goto us;
  }
if ( j > 1 )
  {
    fin=fopen(argc[1],"r");
    if ( fin == NULL )
      {
	fprintf(stderr,"cob2sql: cannot open \"%s\" file\n",argc[1]);
	goto us;
      }
  }

while ( (i=fread(buf+k,1,BUFFSIZE-k,fin)) || k )
  {
    k+=i;
    for (i=0;i<k;i++)
      switch ( buf[i] )
        {
	  case 10:
	  case 12:
	  case 13:
	  case '.':
	    buf[i]=0;
	  case 0:
	    i++;
	    goto sl;
        }
sl:
    j=0;
    m=0;
    for (l=0;l<MAXCOLUMNS;l++)
      {
        memset(colname[l],0,MAXCOLNAME);
	while ( isgraph(buf[j]) ) j++;
	memcpy(colname[l],&buf[m],j-m);
	while ( isspace(buf[j]) ) j++;
	if ( buf[j] == 0 ) break;
	m=j;
      }
    while ( i < k )
      if ( isgraph(buf[i]) )
	break;
      else
	i++;
    j=i;
    for (i=1;i<l;i++)
      if ( toupper(colname[i][0])=='P' &&
	   toupper(colname[i][1])=='I' &&
	   toupper(colname[i][2])=='C' &&
	   toupper(colname[i][3])==0 )
	{
	  s=colname[i-1];
	  while ( *s )
	    switch ( *s )
	      {
		case '-':
		case '+':
		  *s = '_';
		default:
		  s++;
	      } 
	  s=colname[i+1];
	  m=0;
	  d=0;
sp:	  switch ( *s )
	    {
	      case 'X':
	      case 'x':
		s++;
		if ( *s++ == '(' )
		  m=atoi(s);
		else
		  m=1;
	        if ( f )
		  sprintf(colname[i],
		    "POSITION(%d:%d)\tNULLIF (%d:%d)=BLANKS",
		    n,n+m-1,n,n+m-1);
		else
            	  if ( m > 1 )
              	    sprintf(colname[i],"VARCHAR2(%d)",m);
            	  else
              	    sprintf(colname[i],"CHAR(1)");
	        n+=m;
		break;
	      case '9':
		do m++; while ( *++s == '9' );
		if ( *s == '(' )
		  {
		    s++;
		    if ( isdigit(*s) ) m=atoi(s);
		    while ( isdigit(*s) ) s++;
		  }
		if ( *s == ')' ) s++;
		while ( isalpha(*s) ) s++;
		while ( *s == '9' ) { s++; d++; }
                if ( *s == '(' )
                  {
                    s++;
                    if ( isdigit(*s) ) d=atoi(s);
                  }
	        if ( f )
		  if ( d )
		    sprintf(colname[i],
		    "POSITION(%d:%d)\tFLOAT EXTERNAL NULLIF (%d:%d)=BLANKS",
		    n,n+m+d-1,n,n+m+d-1);
	      	  else
		    sprintf(colname[i],
		    "POSITION(%d:%d)\tINTEGER EXTERNAL NULLIF (%d:%d)=BLANKS",
		    n,n+m+d-1,n,n+m+d-1);
		else
	          sprintf(colname[i],"NUMBER(%d,%d)",m+d,d);
	        n+=m+d;
		break;
	      case 0:
		colname[i][0]=0;
		break;
	      default:
		s++;
		goto sp;
	      }
          fprintf(stdout,"%-34s%s,\n",colname[i-1],colname[i]);
	}
    k-=j;
    memmove(buf,&buf[j],k);
  }
fclose(fin);
exit(0);
}
